#include <iostream>
#include <vector>

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data() {
    size_t number_count;
    Input in;

    cerr << "Enter number count: ";
    cin >> number_count;
    vector<double> numbers(number_count);

    in.numbers.resize(number_count);

    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }

    cerr << "Enter bins count: ";
    cin >> in.bin_count;
    return in;
}

void
    find_minmax(const vector<double>& numbers, double& min, double& max) {
    min = numbers[0];
    max = numbers[0];
    // (     )
    for (double value : numbers)
    {
        if (value < min) {min = value;}
        else if (value > max) {max = value;}
    }
}

int main()
{
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

    Input in = input_data();

    double min, max;
    find_minmax(in.numbers, min, max);

    double max_count = 0;

    size_t bin_count=in.bin_count;
    vector<size_t> bins(bin_count);
    size_t number_count=in.numbers.size();

    double bin_size = (max - min) / bin_count;

    for (size_t i = 0; i < number_count; i++)
    {
        for (size_t j = i + 1; j < number_count; j++)
        {
            if (in.numbers[i] == in.numbers[j])
            {
                //numbers.erase(numbers.begin() + j);
                //number_count--;
                //i--;
                //cout << "Removed number " << numbers[j] << endl;
            }
        }
    }

    for (size_t i = 0; i < number_count; i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
                auto low_bound = min + j * bin_size;
                auto high_bound = min + (j + 1) * bin_size;
                if ((low_bound <= in.numbers[i]) && (in.numbers[i] < high_bound))
                {
                    bins[j]++;
                    found = true;
                    if (bins[j] > max_count)
                        max_count = bins[j];
                }
        }

        if (!found)
        {
            bins[bin_count - 1]++;
            if (bins[bin_count - 1] > max_count)
                        max_count = bins[bin_count - 1];
        }
    }
    for (size_t bin : bins)
    {
        if (bin < 100) cout << " ";
        if (bin < 10) cout << " ";
        cout << bin;
        cout << "|";
        size_t height = MAX_ASTERISK * (static_cast<double>(bin) / max_count);
        if (max_count <= MAX_ASTERISK) height = bin;
        for (size_t i = 0; i < height; i++) cout << "*";
        cout << endl;
    }

    return 0;
}
